﻿USE tempdb;
GO

-- jeszcze przykład z rekurencją dla funkcji

-- utwórz funkcję sumującą
--DROP FUNCTION dbo.SumujDo
CREATE FUNCTION dbo.SumujDo(@liczba INT)
RETURNS INT
AS
BEGIN
	DECLARE @wynik INT = 0

	IF(@liczba > 0)
		SET @wynik = @liczba + dbo.SumujDo(@liczba - 1);

	RETURN @wynik
END

SELECT dbo.SumujDo(10)
SELECT dbo.SumujDo(150)


-- i przykład, który pokazuje, że na pewno CTE jest wyliczane za każdym razem, kiedy się do niego odwołujemy
;WITH Dane AS (
SELECT
	id = NEWID()
)
SELECT
	id
FROM Dane

UNION ALL

SELECT
	id
FROM Dane